# Copyright (C) 2021, KylinSoft Co., Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
# [OK]为修复成功
# 执行修复脚本权限需要root权限执行

from importlib.resources import open_binary
import subprocess
from tabnanny import check


def fix_ssh_disable_port_forwarding():
    try:
        output = subprocess.check_output("grep 'PermitOpen' /etc/ssh/sshd_config", shell=True)
        output = output.decode('utf-8').strip()
         # 运行SSH命令禁用PermitOpen选项
        command = 'sudo sed -i "s/PermitOpen.*/PermitOpen none/g" /etc/ssh/sshd_config'
        result = subprocess.run(command, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)

        if result.returncode == 0:
            print('[OK] The port forwarding function of SSH service has been disabled and fixed')
        else:
            print('[ERROR] Error disabling port forwarding function for SSH service:', result.stderr.decode('utf-8').strip())
    except:
        with open('/etc/ssh/sshd_config','a') as f:
            f.write('PermitOpen none')
        print('[OK] The port forwarding function of SSH service has been disabled and fixed')


if __name__ == '__main__':
    # 运行所有的修复函数
    fix_ssh_disable_port_forwarding()
