# Copyright (C) 2021, KylinSoft Co., Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
import pytest
import os
from BaseLine.LocalServices.filePermissions.check_file_permission.check_file_permission import get_env_lang,is_root,arg_lang,l_print,check_file_permission
from BaseLine.LocalServices.filePermissions.check_file_permission.fix_file_permission import fix_file_permission
def test_get_env_lang(monkeypatch):
    monkeypatch.setattr("BaseLine.LocalServices.filePermissions.check_file_permission.check_file_permission.arg_lang", 'en')
    assert get_env_lang() == "语言环境为英文"
    monkeypatch.setattr("BaseLine.LocalServices.filePermissions.check_file_permission.check_file_permission.arg_lang", 'zh')
    assert get_env_lang() == "语言环境为中文"
    monkeypatch.setattr("BaseLine.LocalServices.filePermissions.check_file_permission.check_file_permission.arg_lang", '')
    assert get_env_lang() == "语言环境未知"
def test_is_root(monkeypatch):
    if os.geteuid() == 0:
        assert is_root() == True
    else:
        assert is_root() == False
def test_l_print(monkeypatch, capsys):
    monkeypatch.setattr("BaseLine.LocalServices.filePermissions.check_file_permission.check_file_permission.arg_lang", 'zh')
    l_print("zh","en")
    captured = capsys.readouterr()
    assert captured.out == "zh\n"
    monkeypatch.setattr("BaseLine.LocalServices.filePermissions.check_file_permission.check_file_permission.arg_lang", 'en')
    l_print("zh","en")
    captured = capsys.readouterr()
    assert captured.out == "en\n"
    monkeypatch.setattr("BaseLine.LocalServices.filePermissions.check_file_permission.check_file_permission.arg_lang", '')
    l_print("zh","en")
    captured = capsys.readouterr()
    assert captured.out == "en\n"
def test_check_file_permission(capsys):
    filepath = "/etc/crontab"
    mode = "644"
    check_file_permission(filepath, mode)
    captured = capsys.readouterr()
    assert captured.out ==  f"[OK] File permission check passed for {filepath}\n"
def test_fix_file_permission(capsys):
    filepath = "/etc/crontab"
    mode = "644"
    fix_file_permission(filepath, mode)
    captured = capsys.readouterr()
    assert captured.out == "[OK] check suff\n"